/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/

%%% Assignment Problem

%%% Loading the libray
:-lib(ic).
:-lib(branch_and_bound). 

%%% assign_tasks/2
%%% assign_tasks(Teams,Cost)
%%% Assigns tasks 1..5 to the teams wrt the constraints.
%%% Cost is the totla cost of the assignment.
assign_tasks(Teams,Cost):-
	Teams = [T1,T2,T3,T4,T5], 
	element(I1,[2,3,4],T1),
	element(I1,[30,10,40],C1),

	element(I2,[1,4,5],T2),
	element(I2,[70,20,140],C2),
	
	element(I3,[2,4,5],T3),
	element(I3,[10,80,100],C3),

	element(I4,[1, 3,4],T4),
	element(I4,[20,40,40],C4),

	element(I5,[1,2,4],T5),
	element(I5,[40,10,10],C5),

	alldifferent(Teams),
	Cost #= C1 + C2 + C3 + C4 + C5,
	labeling(Teams).

%%% assign_tasks/2
%%% assign_tasks(Teams,Cost)
%%% Assigns tasks 1..5 to the teams wrt the constraints.
%%% Cost is the totla cost of the assignment.
%%% Best Cost Solution using Branch and Bound.

assign_tasks_bb(Teams,Cost):-
	Teams = [T1,T2,T3,T4,T5], 
	element(I1,[2,3,4],T1),
	element(I1,[30,10,40],C1),

	element(I2,[1,4,5],T2),
	element(I2,[70,20,140],C2),
	
	element(I3,[2,4,5],T3),
	element(I3,[10,80,100],C3),

	element(I4,[1, 3,4],T4),
	element(I4,[20,40,40],C4),

	element(I5,[1,2,4],T5),
	element(I5,[40,10,10],C5),

	alldifferent(Teams),
	Cost #= C1 + C2 + C3 + C4 + C5,
	bb_min(labeling(Teams),Cost,_).

