/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/


:-lib(ic).

solve(X,Y,Z):-
  member(X, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]), 
  member(Y, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]),
  member(Z, [4, 5, 6, 7, 8, 9, 10, 11]),
  X > 3, X < 9,
  Y > 2, Y < 9,
  X =:= Y + 1,
  Z > 5,		  
  Z < X.

solve_dfs(X,Y,Z):-
  member(X, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]), 
  X > 3, X < 9,
  member(Y, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]),
  Y > 2, Y < 9,
  X =:= Y + 1,  
  member(Z, [4, 5, 6, 7, 8, 9, 10, 11]),
  Z > 5,
  Z < X.


solve_dfs_h(X,Y,Z):-
  member(Z, [4, 5, 6, 7, 8, 9, 10, 11]),
  Z > 5,
  member(X, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]), 
  X > 3, X < 9,
  Z < X, 	 
  member(Y, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]),
  Y > 2, Y < 9,
  X =:= Y + 1.

solve_filter(X,Y,Z):-
  member(Z, [6, 7]),
  member(X, [7, 8]), 
  Z < X, 	 
  member(Y, [6, 7]),
  X =:= Y + 1.

%%% Constraint Version 
solve_clp(X,Y,Z):-
  [X,Y] #:: [1..10],
  Z #:: [4 .. 11],
  X #> 3, X #< 9,
  Y #> 2, Y #< 9,
  X #= Y + 1,
  Z #> 5, Z #< X, 
  labeling([X,Y,Z]). 

%%% solve_clp_ff/3
%%% Solving the problem using the 
%%% search/6 predicate. 
solve_clp_ff(X,Y,Z):-
  [X,Y] #:: [1..10],
  Z #:: [4 .. 11],
  X #> 3, X #< 9,
  Y #> 2, Y #< 9,
  X #= Y + 1,
  Z #> 5, Z #< X, 
  search([X,Y,Z], 0, first_fail, indomain, complete,[]).


