/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/

%%% Libraries Required.
:-use_module(library(ic)).
:-use_module(library(ic_global)).
:-use_module(library(ic_edge_finder)).
:-use_module(library(branch_and_bound)). 

schedule_start_times(teamA([St1,St4,St5]),teamB([St2,St3]),MakeSpan):-
  Starts = [St1,St2,St3,St4,St5],
  Ends = [End1,End2,End3,End4,End5],
  Starts #:: 0..inf,
  Ends #:: 0..inf,
%% Start End Times and Durations,
  End1 #= 5 + St1, End2 #= 4 + St2,
  End3 #= 7 + St3, End4 #= 1 + St4,
  End5 #= 9 + St5,
%% Ordering Constraints
  End1 #=< St2, End3 #=< St5,	
  ic_global:maxlist(Ends,MakeSpan),
%% Assignment to teams and no overlapping constraints 
%%% team A
  disjunctive([St1,St4,St5],[5,1,9]), 
%%% team B
  disjunctive([St2,St3],[4,7]),
%% Search for a Solution
  bb_min(labeling(Starts),MakeSpan,bb_options{strategy:restart}). 


schedule_start_times_r(teamA([St1,St4,St5]),teamB([St2,St3]),MakeSpan):-
  Starts = [St1,St2,St3,St4,St5],
  Ends = [End1,End2,End3,End4,End5],
  Starts #:: 0..inf,
  Ends #:: 0..inf,
%% Start End Times and Durations,
  End1 #= 5 + St1, End2 #= 4 + St2,
  End3 #= 7 + St3, End4 #= 1 + St4,
  End5 #= 9 + St5,
%% Ordering Constraints
  End1 #=< St2, End3 #=< St5,	
  ic_global:maxlist(Ends,MakeSpan),
%% Assignment to teams and no overlapping constraints 
%%% team A
  cumulative([St1,St4,St5],[5,1,9],[1,3,3],5), 
%%% team B
  cumulative([St2,St3],[4,7],[2,2],4),
%% Search for a Solution
  bb_min(labeling(Starts),MakeSpan,bb_options{strategy:restart}). 

